/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (http://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

var SG = SG || {};

SG.ElementScrollBrowser = function(resultList) {
	this.initialize(resultList);
};

SG.ElementScrollBrowser.prototype = {
	/**
	 * @var int
	 */
	lastPage: 1,

	/**
	 * @var boolean
	 */
	lock: false,

	/**
	 * @var object
	 */
	resultList: null,

	/**
	 * @var string
	 */
	url: null,

	/**
	 * @var string
	 */
	lastUrl: null,

	/**
	 * @var object
	 */
	loadIndicator: null,

	/**
	 * Initializes the class members and adds the necessary scroll events
	 *
	 * @return {void}
	 */
	initialize: function(resultList) {
		$('.tx-pagebrowse-pi1').css('display', 'none');
		this.resultList = resultList;
		this.loadIndicator = this.resultList.children(':last');
		if (!this.loadIndicator.length) {
			return;
		}

		this.url = $('.tx-pagebrowse-next a').attr('href');
		$(window).on(
			'scroll', function() {
				if (this.lock || !this.checkPosition() || this.url === undefined || this.url === this.lastUrl) {
					return;
				}

				this.lock = true;
				$.ajax(
					{
						url: this.url,

						beforeSend: function() {
							//var loader = '<li class="tx-sgnews-load-indicator"></li>';
							//resultList.append(loader);
							//resultList.find('.tx-sgnews-indicator').show();
						},

						success: function(response) {
							var results = $(response).find('.tx-sgnews-list').children();
							if (results.length) {
								this.lastUrl = this.url;
								this.url = $(response).find('.tx-pagebrowse-next a').attr('href');
								//resultList.find('.tx-sgnews-load-indicator').remove();
								resultList.append(results);
								this.loadIndicator = resultList.children(':last');
								this.lock = false;
							}
						}.bind(this)
					}
				);
			}.bind(this)
		);
	},

	/**
	 * Checks the current position of the scrollbar in relation to the position of the load indicator.
	 *
	 * @return boolean
	 */
	checkPosition: function() {
		var loadIndicatorPosition = this.loadIndicator.position(),
			windowScrollPosition = $(document).scrollTop();
		return (windowScrollPosition > (loadIndicatorPosition.top - 6000));
	}
};

$(document).ready(
	function() {
		var resultList = $(this).find('.tx-sgnews-list');
		(new SG.ElementScrollBrowser(resultList));
	}
);